/*
 *  main.c
 *
 *  Created by Vincent Legat on 09/01/12.
 *  Edited by Bastien Gorissen on 28/01/13.
 *  Copyright 2012-13 UCL. All rights reserved.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <GL/glfw.h>
#include "glfem.h"


int main( void )
{
    int width, height;
	float ratiox, ratioy;
	
    glfwInit();
	glfwOpenWindow(480,480,0,0,0,0,0,0,GLFW_WINDOW);	
    glfwSetWindowTitle("MECA1120 : Now with graphics");
	
	glShadeModel (GL_SMOOTH);
	glfemMakeRasterFont();
  	
    // Coordinates for the element we are going to draw in the window
    float myX[4] = { 1.0, -1.0, -1.0,  1.0} ;
	float myY[4] = { 1.0,  1.0, -1.0, -1.0} ;
 			
    do
    {
        // Bookkeeping to account for the resizing of the window
        glfwGetWindowSize( &width, &height );
		height = height > 0 ? height : 1;
        glViewport(0,0,width,height );
		
		glClearColor( 0.9f, 0.9f, 0.8f, 0.0f );
		glClear(GL_COLOR_BUFFER_BIT);
	
		glViewport(0, 0, (GLsizei) width, (GLsizei) height);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		ratiox = fmax((float)width/height,1.0)*1.3;
		ratioy = fmax((float)height/width,1.0)*1.3;
		glOrtho (-ratiox, ratiox, -ratioy, ratioy, -1.0, 1.0);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

        // Actual calls to draw the element
        glfemDrawElement(myX,myY,4);
        glColor3f (1.0, 0.0, 0.0);
        glfemDrawNodes(myX,myY,4);


        // Added bonus : how to write text and other variables in the window					
	    glColor3f (0.0, 0.0, 0.0);
        int my_integer = 8;
		char str[256];
		sprintf(str,"You can also write out things, like so : %d", my_integer);
		glfemDrawMessage(24,44,str);
		
		// Call this when you have finished drawing everything and are ready to display it
		glfwSwapBuffers();
		
    } // Check if the ESC key was pressed or the window was closed
    while( glfwGetKey( GLFW_KEY_ESC ) != GLFW_PRESS &&
		   glfwGetWindowParam( GLFW_OPENED ) );
	

	glfwTerminate();	
    exit(EXIT_SUCCESS);
}
